
// nctools.js
// adding button to trigger a trap message

// all timeouts change to 10 seconds for version 2.6: Nov 27 2017


var sxinit = false;  // initial sequencer
var sxaction = false; // action routine: no data returned
			// use for manl too - except K?
var xmlhttpma = false;  // for manl status only




var timeoutidinit;
var sequencecount = 4;
var sequencelist = new Array(4);
var sequencendx;
// string tells what to do: start with C or S
sequencelist[0] = "CVA";  // main firmware
sequencelist[1] = "CVR";  // Rabbit firmware
sequencelist[2] = "SI";    // serial number(s)
sequencelist[3] = "CIC";  // current IP etc.

var timeoutidc;
var timeoutidma;
var refreshtimerma;
var manlmode;
var currentlrm1;
var currentlrm2;
var currentlrm3;

var timeoutidrst;
var timeoutidtrap;

if (window.XMLHttpRequest)
  {
  sxinit = new XMLHttpRequest();
  sxaction = new XMLHttpRequest();
  xmlhttpma = new XMLHttpRequest();
  }
else if (window.ActiveXObject)
  {
  sxinit = new ActiveXObject("Microsoft.XMLHTTP");
  sxaction = new ActiveXObject("Microsoft.XMLHTTP");
  xmlhttpma = new ActiveXObject("Microsoft.XMLHTTP");
  }
else
  {
  alert("Browser does not support XmlHttpRequest object, ie Ajax: upgrade");
  }




function doalert(str)
// really want to put in alert field - later
  {
  alert(str);
  }

function sysalert(str)
// should be impossible; error in Javascript
  {
  alert("SYSTEM ERROR:\n" + str);
  }



function dosequencer()
  {
  var url;
  var ajaxmsg;
  var x;
  x=sequencelist[sequencendx].charAt(0);
  if (x=='C') url="config.cgi";
  else if (x=='S') url="status.cgi";
  else
    {
    doalert("Bad sequencer element - aborting");
    return;
    }
  ajaxmsg = sequencelist[sequencendx].slice(1);  // start after first char
  if ( (sxinit.readyState==4) || (sxinit.readyState==0) )
    {
    sxinit.open("POST", url, true);
    sxinit.onreadystatechange = sxinitreturn;
    sxinit.send(ajaxmsg);
    timeoutidinit = window.setTimeout("timeoutrtninit();", 10000);
    }
  else
    {
    doalert("Sequencer stuck - aborting");
    return;
    }
  }


function timeoutrtninit()
  {
  // get here if sequencer times out - allow 5 before alerting
  // no - not alerting at all now; but might put back in
  dosequencer();  // continue to try
  }

function tools_initialize()
  {
  maactive=0;
  document.getElementById("mamainbutton").value = "Activate";
  regactive=0;
  document.getElementById("regmainbutton").value = "Activate";
  rstactive=0;
  document.getElementById("rstmainbutton").value = "Activate";
  trapactive=0;
  document.getElementById("trapmainbutton").value = "Activate";
  sequencendx=0;
  dosequencer();  // will enable buttons and start refresh when done
  }


function findkeypos(str)
  {
  // return the position of the "key" in str
  // key can be ! or _ or : or ^
  // has to be 0, 1, or 2: else no key, return0
  var pos;
  pos = str.search(/[\!\:\_\^]/);
  if (pos==-1) pos=0;
  if (pos>2) pos=0;
  return pos;
  }



function sxinitreturn()
  {
  var str0;
  var keypos;
  var str1;
  var splitstr;
  // check to see if finished
  if ( (sxinit.readyState==4) && (sxinit.status==200) )
    {
    // get it! process
    window.clearTimeout(timeoutidinit);
    numtimeouts=0;
    str0 = sxinit.responseText;
    keypos = findkeypos(str0);
    if (str0.charAt(keypos) != ":")
      {
      // error return - should be impossible
      doalert("Unexpected response [" + str0 + "]");
      dosequencer();  // keep retrying
      return;
      }
    // here, is ok
    // we know where it came from: don't need to parse
    str1 = str0.slice(keypos+1);
    badresp=0;  // default
    if (sequencendx==0)
	{
	// VA to config: get main firmware
	splitarray = str1.split("$");
	if (splitarray.length!=4) badresp=1;
	document.getElementById("mainfw").innerHTML = splitarray[0];
	}
    else if (sequencendx==1)
	{
	// VR to config: get comm firmware
	document.getElementById("commfw").innerHTML = str1;
	}
    else if (sequencendx==2)
	{
	// I to status: get serial numbers
	splitarray = str1.split(";");
	if (splitarray.length!=3) badresp=1;
	document.getElementById("sernum").innerHTML = splitarray[2];
	}
    else if (sequencendx==3)
	{
	// IC to config: current IP etc.
	splitarray = str1.split(";");
	if (splitarray.length!=6) badresp=1;
	document.getElementById('currentip').innerHTML = splitarray[0];
	document.getElementById('currentmask').innerHTML = splitarray[1];
	document.getElementById('currentgate').innerHTML = splitarray[2];
	document.getElementById('currentname').innerHTML = splitarray[3];
	document.getElementById('currentmac').innerHTML = splitarray[4];
	}
    else
	{
	sysalert("Error: sequencendx=" + sequencendx);
	sequencendx=3;  // abort sequence
	}
    if (badresp) doalert("Bad response: [" + str0 + "]");
    if (sequencendx==3)
	{
	// end of sequencer
	sequencendx=0;
	}
    else
	{
	sequencendx++;
	dosequencer();
	}
    }
  }


// ******************************************************

var maactive=0
var regactive=0;
var rstactive=0;
var trapactive=0;

// ******************************************************

function forceregen(which)
// with verification - too easy to hit by mistake
// but this is NOT the right way to do it!
// now has a parameter: 0=user, else 1 or 2 = canister 1 or 2
// not checked
  {
  var message;
  message = "\nDo you really want to force regeneration\n" ;
  if (which==0) message = message + "of canister in use?\n";
  else message = message + "of canister " + which + "\n";
  message =
    message +  "Click OK to force regeneration, Cancel to leave it as is";
  // this is bad manners - fix up later
  if (confirm(message))
    {
    actionrtn("W" + which);
    }
  }



// routines to go on/ off line
// to simplify life, use same routine for reboot command
// but it goes to different url - check for text
function actionrtn(param)
  {
  var url;
  if (param=="RESET2!!") url="config.cgi"; else url="status.cgi";
  // use XmlHttpRequest to get string from server
  if ( (sxaction.readyState==4) || (sxaction.readyState==0) )
     {
     // ok to do it: set up as POST request to whatever
     sxaction.open("POST", url, true);
     // set up function to be called when state changes
     sxaction.onreadystatechange = actionrtnret;
     sxaction.send(param);  // send it
     timeoutidc = window.setTimeout("timeoutrtnact();", 10000);
     }
  }

function actionrtnret()
  {
  // action rtn now also used for K commands - manual mode
  // but process response differently
  // also adding trap: ! is a valid response
  var str0;
  var str1;
  var keypos;
  var prestr;
  var poststr;
  if ((sxaction.readyState==4) && (sxaction.status==200) )  
    {
    window.clearTimeout(timeoutidc);
    str0 = sxaction.responseText;
    if (str0.charAt(0)=='K')
	{
	// really a manual mode request
	processmastring(str0);
	return;
	}
    str1 = str0.slice(keypos+1);
    keypos = findkeypos(str0);
    prestr=str0.slice(0,keypos);  // tells which command it was
    if (prestr=='&')
	{
	// can be &!Traps not enabled  or &_Trap triggered: just show message
	if ( (str0.charAt(keypos)=="!") || (str0.charAt(keypos)=="_") )
	  {
	  // put in message, remove after timeout
	  poststr = str0.slice(keypos+1);  // to end of string
	  document.getElementById("trapmessage").innerHTML = poststr;
	  timeoutidtrap = window.setTimeout("timeoutrtntrap();", 2500);
	  // remove message after 2.5 seconds
	  }
	else
	  {
	  // error condition: alert and return
	  alert(str1);
	  }
	return;
	}
    if (str1.charAt(keypos) == "!")
	{
	// error condition: alert and return
	alert(str1);
	return;
	}
    if (str1.charAt(keypos) == '^')
	{
	// this should only happen with reset; but check it out
	if (prestr=="R2")
	  {
	  // resetting: put in message, remove after timeout
	  document.getElementById("resetmessage").innerHTML = "Rebooting";
	  timeoutidrst = window.setTimeout("timeoutrtnrst();", 2500);
	  // remove message after 2.5 seconds
	  }
	else alert("Unexpected return: [" + str0 + "]");
	}
    // if ok - just do nothing
    }
  }


function timeoutrtnact()
  {
  // gets called if the xmlhttp request times out
  // clear it and reenable the window; also alert
  sxaction.abort();
  doalert("Request timed out");
  }


function timeoutrtnrst()
  {
  // gets called if we get a "rebooting" response to reboot command
  // clears the message
  document.getElementById("resetmessage").innerHTML = "";
  }

function timeoutrtntrap()
  {
  // gets called after response to trap trigger message
  // clears the message
  document.getElementById("trapmessage").innerHTML = "";
  }

// ************************************************************************
// activation
function maflipactive()
  {
  if (maactive)
    {
    killma();
    maactive=0;
    document.getElementById("mamainbutton").value = "Activate";
    }
  else
    {
    initializema();
    maactive=1;
    document.getElementById("mamainbutton").value = "Deactivate";
    }
  }

function regflipactive()
  {
  if (regactive)
    {
    killreg();
    regactive=0;
    document.getElementById("regmainbutton").value = "Activate";
    }
  else
    {
    initializereg();
    regactive=1;
    document.getElementById("regmainbutton").value = "Deactivate";
    }
  }


// reg has nothing special in initialize/killing it
function initializereg()
  {
  document.getElementById("regdiv").style.display = "block";
  }

function killreg()
  {
  document.getElementById("regdiv").style.display = "none";
  }



function rstflipactive()
  {
  if (rstactive)
    {
    killrst();
    rstactive=0;
    document.getElementById("rstmainbutton").value = "Activate";
    }
  else
    {
    initializerst();
    rstactive=1;
    document.getElementById("rstmainbutton").value = "Deactivate";
    }
  }


// rst has nothing special in initialize/killing it
function initializerst()
  {
  document.getElementById("rstdiv").style.display = "block";
  }

function killrst()
  {
  document.getElementById("rstdiv").style.display = "none";
  }



// trap too now

function trapflipactive()
  {
  if (trapactive)
    {
    killtrap();
    trapactive=0;
    document.getElementById("trapmainbutton").value = "Activate";
    }
  else
    {
    initializetrap();
    trapactive=1;
    document.getElementById("trapmainbutton").value = "Deactivate";
    }
  }


// trap has nothing special in initialize/killing it
function initializetrap()
  {
  document.getElementById("trapdiv").style.display = "block";
  }

function killtrap()
  {
  document.getElementById("trapdiv").style.display = "none";
  }





// *****************************************************************
// alarm relay control and status:

function gotomanlauto(toauto)
  {
  // just set up all the disableds etc. - internal only
  // if toauto=1: go to auto mode, disable all the buttons
  // if toauto=0: reverse
  // if entering manual mode from auto, set requested=current
  if (toauto)
     {
     document.getElementById("modebutton").value = "Enter Manual Mode";
     document.getElementById("mamode").innerHTML = "Automatic";
     if (manlmode)
	{
	// entering auto mode: don't need any extras now
	manlmode=0;
	}
     }
  else
     {
     document.getElementById("modebutton").value = "Leave Manual Mode";
     document.getElementById("mamode").innerHTML = "Manual"; 
     if (!manlmode)
	{
	// entering manl mode: set check boxes according to current
	manlmode=1;
	document.getElementById("ma1req").checked = currentlrm1;
	document.getElementById("ma2req").checked = currentlrm2;
	document.getElementById("ma3req").checked = currentlrm3;
	}
     }
  document.getElementById("restartbutton").disabled = toauto;
  document.getElementById("ma1req").disabled = toauto;
  document.getElementById("ma2req").disabled = toauto;
  document.getElementById("ma3req").disabled = toauto;
  }



function initializema()
  {
  manlmode=0;
  currentlrm1=0;  // just to have it be initialized
  currentlrm2=0;
  currentlrm3=0;
  gotomanlauto(1);  // start out - assume auto mode
  document.getElementById("madiv").style.display = "block";
  magetstat();  // initialize
  }

function killma()
  {
  xmlhttpma.abort();
  window.clearTimeout(timeoutidma);
  window.clearTimeout(refreshtimerma);
  document.getElementById("madiv").style.display = "none";
  }

function maflipmode()
  {
  if (manlmode)
    {
    // now in manl mode: request auto
    // don't change the page until get a response
    actionrtn("K0");
   }
  else
    {
    // in auto mode: go to manual, keep current alarm values
    actionrtn("K1");
    }
  }


function marefreshrtn()
  {
  // refresh timer set when request times out or response comes in
  magetstat();
  }

function timeoutrtnma()
  {
  // get here if xmlhttp timer runs out - abort request, resend
  xmlhttpma.abort();
  magetstat();
  }

function magetstat()
  {
  if ( (xmlhttpma.readyState==4) || (xmlhttpma.readyState==0) )
     {
     xmlhttpma.open("POST", "status.cgi", true);
     // set up function to be called when state changes
     xmlhttpma.onreadystatechange = mareturnrtn;
     xmlhttpma.send("K?");  // send it
     timeoutidma = window.setTimeout("timeoutrtnma();", 10000);
     }
  }

function masendlrms()
  {
  // get from check boxes
  var lrmbyte;
  lrmbyte=0x41;  // ascii A
  if (document.getElementById("ma1req").checked) lrmbyte += 1;
  if (document.getElementById("ma2req").checked) lrmbyte += 2;
  if (document.getElementById("ma3req").checked) lrmbyte += 4;
  actionrtn("K" + String.fromCharCode(lrmbyte));
  }


function processmastring(str0)
  {
  // could be from either request object
  var str1;
  var prestr;
  var keypos;
  var ok;
  keypos = findkeypos(str0);
  ok=1;  // set to 0 if error
  if (keypos!=2) ok=0;
  else
      {
      str1 = str0.slice(3);
      prestr=str0.slice(0,2);  // tells which command it was
      if (str0.charAt(2) == '_')
	{
	// response to a K0 or K1 or Kx: says it is ok
	// if K0 or K1, do the mode flip; otherwise ignore
	if (prestr=="K0") gotomanlauto(1);  // to auto mode
	if (prestr=="K1") gotomanlauto(0);  // to manl mode
	}
      else if ((str0.charAt(2) == ':') && (prestr=="K?") )
	 ok=processmaresponse(str1);
      else ok=0;
      }
  if (!ok) alert("Unexpected response: [" + str0 + "]");
  }


function mareturnrtn()
  {
  var str0;
  // check to see if finished
  if ((xmlhttpma.readyState==4) && (xmlhttpma.status==200) )  
    {
    window.clearTimeout(timeoutidma);
    window.clearTimeout(refreshtimerma);
    refreshtimerma=window.setTimeout("marefreshrtn();", 500);  // 1/2 sec
    // process incoming message
    str0 = xmlhttpma.responseText;
    processmastring(str0);
    }
  }

function processmaresponse(str)
  {
  // just the data part; response to K?
  // return 1 if ok, 0 if error
  var x;
  if (str.length != 6) return 0;
  x=str.charAt(0);  // auto or manl
  if (x=='+') gotomanlauto(0);
  else if (x=='-') gotomanlauto(1);
  else return 0;

  x=str.charAt(1);  // alarm 1
  if (x=='+')
    {
    document.getElementById("ma1now").innerHTML = "Y";
    currentlrm1=1;
    }
  else if (x=='-')
    {
    document.getElementById("ma1now").innerHTML = "N";
    currentlrm1=0;
    }
  else return 0;

  x=str.charAt(2);  // alarm 2
  if (x=='+')
    {
    document.getElementById("ma2now").innerHTML = "Y";
    currentlrm2=1;
    }
  else if (x=='-')
    {
    document.getElementById("ma2now").innerHTML = "N";
    currentlrm2=0;
    }
  else return 0;

  x=str.charAt(3);  // alarm 3
  if (x=='+')
    {
    document.getElementById("ma3now").innerHTML = "Y";
    currentlrm3=1;
    }
  else if (x=='-')
    {
    document.getElementById("ma3now").innerHTML = "N";
    currentlrm3=0;
    }
  else return 0;

  document.getElementById("matime").innerHTML = str.substring(4,6);
  return 1;
  }


